Unit TicTacToe;
Interface
Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Buttons, ExtCtrls, Spin, Menus;

 Const FMax=4;MinInt=-300000;MaxInt=300000;
       Farben:Array[0..FMax]of TColor=(clMaroon,clGreen,clRed,clLime,clFuchsia);
                                // 1-3 Computer ... 4-6 Spieler
       RWerte:Array[1..6]of Integer=(5,100,5000,10,200,10000);
 Type // eigene Typen
  Inhalt=Record
           Art,Anzahl:Integer;
           Wo:Array[1..4]of Integer
          End;
   BInhalt=Record Wert,Anzahl:Integer End;
   Nr=Record FeldNr:Array[1..3]of Integer End;
   SpielFeld=Array[1..9]of Inhalt;
   Bewertung=Array[1..8]of BInhalt;
   SpielZug=Integer;
   SpielZugListe=Array[1..9]of SpielZug;
   Spieler=(Computer,Mensch);

  TStrategie = class(TForm)  // Typen von Delfi erstellt
    SpielText: TStaticText;
    Ausgabe: TMemo;
    LabelSieger: TLabel;
    Feld: TDrawGrid;
    MainMenu: TMainMenu;
    StartZug: TMenuItem;
    ComputerStart: TMenuItem;
    MenschStart: TMenuItem;
    Bewertungsanzeige: TMenuItem;
    BewertungAnzeigen: TMenuItem;
    BewertungAusblenden: TMenuItem;
    Algorithmus: TMenuItem;
    MiniMaxVerfahren: TMenuItem;
    AlphaBetaVerfahren: TMenuItem;
    Spielstaerke: TMenuItem;
    Level1: TMenuItem;
    Level2: TMenuItem;
    Level3: TMenuItem;
    Level4: TMenuItem;
    Level5: TMenuItem;
    Level6: TMenuItem;
    Level7: TMenuItem;
    Level8: TMenuItem;
    Level9: TMenuItem;
    Start: TMenuItem;
    Procedure StartClick(Sender: TObject);
    Procedure Init;
    Procedure NeuesSpiel(Var Amzug:Spieler);
    Procedure FeldDrawCell(Sender: TObject; Col, Row: Integer; Rect: TRect;
                           State: TGridDrawState);
    Procedure MachZug(Var F:SpielFeld;Var B:Bewertung;Zug:SpielZug;Amzug:Spieler);
    Function Wert(B:Bewertung):Integer;
    Procedure GenZugListe(F:SpielFeld;Amzug:Spieler;Var N:Integer;
                          Var ZL:SpielZugListe);
    Function Remis(B:Bewertung):Boolean;
    Function Schluss(B:Bewertung):Boolean;
    Procedure MinmaxSuche(Var BestZug:SpielZug;Var MinMax:Integer;
                           B:Bewertung;N:Integer;F:SpielFeld;Amzug:Spieler);
    Procedure AlphaBetaSuche(Var BestZug:SpielZug;Var AlphaBeta:Integer;
           B:Bewertung;N:Integer;F:SpielFeld;Amzug:Spieler;Alpha,Beta:Integer);
    Function SpielEnde:Boolean;
    Procedure ComputerZug;
    Procedure FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
    Procedure FormCreate(Sender: TObject);
    Procedure FeldMouseDown(Sender: TObject; Button: TMouseButton;
                            Shift: TShiftState; X, Y: Integer);
    procedure ComputerStartClick(Sender: TObject);
    procedure MenschStartClick(Sender: TObject);
    procedure BewertungAnzeigenClick(Sender: TObject);
    procedure BewertungAusblendenClick(Sender: TObject);
    procedure MiniMaxVerfahrenClick(Sender: TObject);
    procedure AlphaBetaVerfahrenClick(Sender: TObject);
    procedure LevelWahl(Sender: TObject);
  Private { Private-Deklarationen }
    Reihe:Array[1..8]of Nr;
    B:Bewertung;
    Dran:Spieler;
    Tiefe,Zuege:Integer;
    Count:Integer;
    Anzeigen:Boolean;
    F:SpielFeld;
  Public { Public-Deklarationen }
  End;

Var Strategie: TStrategie;

Implementation

{$R *.DFM}
{$R+,Q+} // die Bereichsberprfung und die berlaufprfung ist aktiviert
         //         Arrays                   Wertebereich
 Procedure TStrategie.Init;
  Var K,L,I:Integer;
      Zeile:String;
  Begin
   For K:=1 To 3 Do
    Begin
     For L:=1 To 3 Do Reihe[L].FeldNr[K]:=(L-1)*3+K;
     For L:=4 To 6 Do Reihe[L].FeldNr[K]:=3*K+L-6;
     Reihe[7].FeldNr[K]:=7-2*(K-1);
     Reihe[8].FeldNr[K]:=1+4*(K-1)
    End;
   Ausgabe.Lines.Add('Gewinnreihen');
   For L:=1 To 8 Do
    Begin
     Zeile:=IntToStr(L)+') ';
     For K:=1 To 2 Do Zeile:=Zeile+IntToStr(Reihe[L].FeldNr[K])+' - ';
     Zeile:=Zeile+IntToStr(Reihe[L].FeldNr[3]);
     Ausgabe.Lines.Add(Zeile);
    End;
   For I:=1 To 9 Do
    Begin
     F[I].Art:=0;F[I].Anzahl:=0;
     For L:=1 To 8 Do
      For K:=1 To 3 Do
       If Reihe[L].FeldNr[K]=I Then
        Begin Inc(F[I].Anzahl);F[I].Wo[F[I].Anzahl]:=L End
    End;
   Ausgabe.Lines.Add('');Ausgabe.Lines.Add('Feldinhalte');
   For I:=1 To 9 Do
    Begin
     Zeile:=IntToStr(I)+') ';
     For K:=1 To F[I].Anzahl-1 Do Zeile:=Zeile+IntToStr(F[I].Wo[K])+' - ';
     Zeile:=Zeile+IntToStr(F[I].Wo[F[I].Anzahl]);
     Ausgabe.Lines.Add(Zeile);
    End;
  End;

 Procedure TStrategie.NeuesSpiel(Var Amzug:Spieler);
  Begin
   LabelSieger.Caption:='';
   Feld.Enabled:=True;Ausgabe.Clear;
   If MenschStart.Checked Then Amzug:=Mensch
   Else Amzug:=Computer;
   If BewertungAnzeigen.Checked Then
    Begin Anzeigen:=True;Ausgabe.Visible:=True End
   Else Begin Anzeigen:=False;Ausgabe.Visible:=False End
  End;

 Procedure TStrategie.MachZug(Var F:SpielFeld;Var B:Bewertung;
                              Zug:SpielZug;Amzug:Spieler);
  Var L:Integer;
  Begin
   If Amzug=Computer Then F[Zug].Art:=1 Else F[Zug].Art:=2;
   For L:=1 To F[Zug].Anzahl Do
    with B[F[Zug].Wo[L]] Do
     Begin Wert:=Wert or F[Zug].Art;Inc(Anzahl) End;
  End;

 Function TStrategie.Wert(B:Bewertung):Integer;
  Var T,Sp,Com:Integer;
  Begin
   Sp:=0;Com:=0;
   For T:=1 To 8 Do
    If B[T].Wert=1 Then Com:=Com+RWerte[B[T].Anzahl]
    Else
     If B[T].Wert=2 Then Sp:=Sp+RWerte[B[T].Anzahl+3];
   Wert:=Com-Sp;Inc(Count)
  End;

 Procedure TStrategie.GenZugListe(F:SpielFeld;Amzug:Spieler;Var N:Integer;
                                  Var ZL:SpielZugListe);
  Var K:Integer;
  Begin
   N:=0;
   For K:=1 To 9 Do If F[K].Art=0 Then Begin Inc(N);ZL[N]:=K End;
  End;

 Function TStrategie.Remis(B:Bewertung):Boolean;
  Var K:Integer;
  Begin
   Remis:=True;
   For K:=1 To 8 Do
    If B[K].Wert<3 Then
     Begin Remis:=False;Exit End;
  End;

 Function TStrategie.Schluss(B:Bewertung):Boolean;
  Var Sieg,K:Integer;
  Begin
   Sieg:=0;
   For K:=1 To 8 Do
    Begin
     If B[K].Wert=1 Then
      Begin If B[K].Anzahl=3 Then Sieg:=1 End
     Else
      If B[K].Wert=2 Then
       Begin If B[K].Anzahl=3 Then Sieg:=2 End;
    End;
   Schluss:=Sieg>0
  End;

 Procedure TStrategie.MinmaxSuche(Var BestZug:SpielZug;Var MinMax:Integer;
                             B:Bewertung;N:Integer;F:SpielFeld;Amzug:Spieler);
  Var VirtuelleFeld:SpielFeld;
      VirtuelleBewertung:Bewertung;
      Zug:SpielZug;
      ZugListe:SpielZugListe;
      I,Anzahl,Zeile,Spalte:Integer;
      AbZeile:String;
      M:Integer;
  Begin
   If (N=0) or Schluss(B) or Remis(B) Then MinMax:=Wert(B)
   Else
    Begin
     GenZugListe(F,Amzug,Anzahl,ZugListe);
     If Amzug=Computer Then
      Begin
       M:=MinInt;I:=0;
       While I<Anzahl Do
        Begin
         VirtuelleFeld:=F;VirtuelleBewertung:=B;Inc(I);Zug:=ZugListe[I];
         MachZug(VirtuelleFeld,VirtuelleBewertung,Zug,Computer);
         MinmaxSuche(BestZug,MinMax,VirtuelleBewertung,N-1,
                     VirtuelleFeld,Mensch);
         If (N=Tiefe) And Anzeigen Then
          Begin
           Zeile:=Zug Div 3+1;Spalte:=Zug Mod 3;
           If Spalte=0 Then Begin Spalte:=3;Dec(Zeile) End;
           AbZeile:='Wert von Zug : ('+IntToStr(Zeile)+'|'+IntToStr(Spalte);
           AbZeile:=AbZeile+')='+IntToStr(MinMax);
           Ausgabe.Lines.Add(AbZeile);
           AbZeile:=IntToStr(Count)+' analysierte Stellungen';
           Ausgabe.Lines.Add(AbZeile);
          End;
         If M<MinMax Then
          Begin
           M:=MinMax;
           If N=Tiefe Then
            Begin
             BestZug:=Zug;
             If Anzeigen Then
              Begin
               Zeile:=BestZug Div 3+1;
               Spalte:=BestZug Mod 3;
               If Spalte=0 Then Begin Spalte:=3;Dec(Zeile) End;
               AbZeile:='bisher bester ComputerZug : ('+IntToStr(Zeile)+'|';
               AbZeile:=AbZeile+IntToStr(Spalte)+')='+IntToStr(MinMax);
               Ausgabe.Lines.Add(AbZeile);
              End
            End
          End
        End
      End
     Else
      Begin
       M:=MaxInt;I:=0;
       While I<Anzahl Do
        Begin
         VirtuelleFeld:=F;VirtuelleBewertung:=B;Inc(I);Zug:=ZugListe[I];
         MachZug(VirtuelleFeld,VirtuelleBewertung,Zug,Mensch);
         MinmaxSuche(BestZug,MinMax,VirtuelleBewertung,N-1,
                     VirtuelleFeld,Computer);
         If M>MinMax Then M:=MinMax
        End
      End;
     MinMax:=M
    End
  End;

 Procedure TStrategie.AlphaBetaSuche(Var BestZug:SpielZug;Var AlphaBeta:Integer;
            B:Bewertung;N:Integer;F:SpielFeld;Amzug:Spieler;Alpha,Beta:Integer);
  Var VirtuelleFeld:SpielFeld;
      Zug:SpielZug;
      ZugListe:SpielZugListe;
      VirtuelleBewertung:Bewertung;
      M:Integer;
      I,Anzahl,Zeile,Spalte:Integer;
      AbZeile:String;
  Begin
   If (N=0) or Schluss(B) or Remis(B) Then AlphaBeta:=Wert(B)
   Else
    Begin
     GenZugListe(F,Amzug,Anzahl,ZugListe);
     If Amzug=Computer Then
      Begin
       M:=Alpha;I:=0;
       While (I<Anzahl) And (M<Beta) Do
        Begin
         VirtuelleFeld:=F;VirtuelleBewertung:=B;Inc(I);Zug:=ZugListe[I];
         MachZug(VirtuelleFeld,VirtuelleBewertung,Zug,Computer);
         AlphaBetaSuche(BestZug,AlphaBeta,VirtuelleBewertung,N-1,VirtuelleFeld,
                        Mensch,M,Beta);
         If (N=Tiefe) And Anzeigen Then
          Begin
           Zeile:=Zug Div 3+1;Spalte:=Zug Mod 3;
           If Spalte=0 Then Begin Spalte:=3;Dec(Zeile) End;
           AbZeile:='Wert von Zug : ('+IntToStr(Zeile)+'|'+IntToStr(Spalte);
           AbZeile:=AbZeile+')='+IntToStr(AlphaBeta);
           Ausgabe.Lines.Add(AbZeile);
           AbZeile:=IntToStr(Count)+' analysierte Stellungen';
           Ausgabe.Lines.Add(AbZeile);
          End;
         If M<AlphaBeta Then
          Begin
           M:=AlphaBeta;
           If N=Tiefe Then
            Begin
             BestZug:=Zug;
             If Anzeigen Then
              Begin
               Zeile:=BestZug Div 3+1;
               Spalte:=BestZug Mod 3;
               If Spalte=0 Then Begin Spalte:=3;Dec(Zeile) End;
               AbZeile:='bisher bester ComputerZug : ('+IntToStr(Zeile)+'|';
               AbZeile:=AbZeile+IntToStr(Spalte)+')='+IntToStr(AlphaBeta);
               Ausgabe.Lines.Add(AbZeile);
              End
            End
          End
        End
      End
     Else
      Begin
       M:=Beta;I:=0;
       While (I<Anzahl) And (M>Alpha) Do
        Begin
         VirtuelleFeld:=F;VirtuelleBewertung:=B;Inc(I);Zug:=ZugListe[I];
         MachZug(VirtuelleFeld,VirtuelleBewertung,Zug,Mensch);
         AlphaBetaSuche(BestZug,AlphaBeta,VirtuelleBewertung,N-1,VirtuelleFeld,
                        Computer,Alpha,M);
         If M>AlphaBeta Then M:=AlphaBeta
        End
      End;
     AlphaBeta:=M
    End
  End;

 Function TStrategie.SpielEnde:Boolean;
  Var K,Sieg,SiegerReihe:Integer;
  Begin
   SpielEnde:=False;Sieg:=0;SiegerReihe:=0;
   For K:=1 To 8 Do
    Begin
     If B[K].Wert=1 Then
      Begin If B[K].Anzahl=3 Then Begin Sieg:=1;SiegerReihe:=K End End
     Else
      If B[K].Wert=2 Then
       Begin If B[K].Anzahl=3 Then Begin Sieg:=2;SiegerReihe:=K End End
    End;
   If Sieg>0 Then
    Begin
     SpielEnde:=True;
     If Sieg=1 Then LabelSieger.Caption:='Ich habe gewonnen'
     Else LabelSieger.Caption:='Du hast gewonnen.';
     For K:=1 To 3 Do
      F[Reihe[SiegerReihe].FeldNr[K]].Art:=Sieg+2;
     Feld.Repaint;
    End;
  End;

 Procedure TStrategie.ComputerZug;
  Var AlphaBeta,MinMaxWert:Integer;
      BestZug:SpielZug;
  Begin
   Screen.Cursor:=crHourGlass;
   Count:=0;If Anzeigen Then AUSGABE.Clear;
   If AlphaBetaVerfahren.Checked Then
    AlphaBetaSuche(BestZug,AlphaBeta,B,Tiefe,F,Computer,MinInt,MaxInt)
   Else MinmaxSuche(BestZug,MinMaxWert,B,Tiefe,F,Computer);
   MachZug(F,B,BestZug,Computer);
   Feld.Repaint; // Feld neu zeichnen
   Screen.Cursor:=crDefault;Inc(Zuege);
   If Remis(B) Then LabelSieger.Caption:='Remis'
   Else If Schluss(B) Then SpielEnde
  End;

 Procedure TStrategie.StartClick(Sender: TObject);
  Begin
   NeuesSpiel(Dran);Init;FillChar(B,SIZEOF(B),0); // B=0 setzen
   Zuege:=0;Feld.Repaint;Feld.Enabled:=True;
   If Dran=Computer Then ComputerZug;
  End;

 Procedure TStrategie.FeldDrawCell(Sender: TObject; Col, Row: Integer;
                                   Rect: TRect; State: TGridDrawState);
  Var Nr:Integer;
  Begin
   Nr:=Col+1+3*Row;
   with Feld.Canvas Do
    Begin
     Case F[Nr].Art of
       0 : Begin
            Brush.Style:=bsSolid;Brush.Color:=Farben[0];
            FillRect(Rect)
           End;
      1,3: Begin
            Brush.Style:=bsSolid;Brush.Color:=Farben[0]; FillRect(Rect);
            Pen.Width:=6;Pen.Color:=Farben[F[Nr].Art];
            MoveTo(Rect.Left+5,Rect.Top+5);
            LineTo(Rect.Right-5,Rect.Bottom-5);
            MoveTo(Rect.Left+5,Rect.Bottom-5);
            LineTo(Rect.Right-5,Rect.Top+5);
           End;
      2,4: Begin
            Brush.Style:=bsSolid;Brush.Color:=Farben[0];FillRect(Rect);
            Pen.Width:=6;Pen.Color:=Farben[F[Nr].Art];
            Ellipse(Rect.Left+5,Rect.Top+5,Rect.Right-5,Rect.Bottom-5);
           End;
     End;
    End;
  End;

 Procedure TStrategie.FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
  Begin
   CanClose:=MessageDlg('Beenden?',mtConfirmation,[mbYes,mbNo],0)=mrYes;
   if CanClose then MessageDlg('Spielende',mtInformation,[mbYes],0)
  End;

 Procedure TStrategie.FormCreate(Sender: TObject);
  Const ScreenHeightDev=768;ScreenWidthDev=1024; // Screen des Entwicklers
  Var X,Y:Integer;
  Begin
   Scaled:=True;X:=Screen.Width;Y:=Screen.Height;
   If (Y<>ScreenHeightDev) or (X<>ScreenWidthDev) Then
    Begin
     Height:=(ClientHeight*Y Div ScreenHeightDev)+Height-ClientHeight;
     Width:=(ClientWidth*X Div ScreenWidthDev)+Height-ClientHeight;
     ScaleBy(X,ScreenwidthDev);
    End;
   Randomize;Feld.Enabled:=False;
   Dran:=Computer;Tiefe:=1;
  End;

 Procedure TStrategie.FeldMouseDown(Sender: TObject; Button: TMouseButton;
                                    Shift: TShiftState; X, Y: Integer);
  Var FeldNr,Col,Row:Integer;
  Begin
   If Schluss(B) or Remis(B) Then Exit;
   Feld.MouseToCell(X,Y,Col,Row); // Mauskoordinaten umrechnen in Spalte Zeile
   FeldNr:=(Col+1)+3*Row;
   If F[FeldNr].Art=0 Then
    Begin
     MachZug(F,B,FeldNr,Mensch);
     Inc(Zuege);
     If Remis(B) Then LabelSieger.Caption:='Remis'
     Else If Schluss(B) Then SpielEnde
          Else ComputerZug
    End
  End;

 procedure TStrategie.ComputerStartClick(Sender: TObject);
  begin
   ComputerStart.Checked:=True;
   Dran:=Computer;
  end;

 procedure TStrategie.MenschStartClick(Sender: TObject);
  begin
   MenschStart.Checked:=True;
   Dran:=Mensch;
  end;

 procedure TStrategie.BewertungAnzeigenClick(Sender: TObject);
  begin
   BewertungAnzeigen.Checked:=True;
   ClientHeight:=480;Ausgabe.Visible:=True;
  end;

 procedure TStrategie.BewertungAusblendenClick(Sender: TObject);
  begin
   BewertungAusblenden.Checked:=True;
   ClientHeight:=280;Ausgabe.Visible:=False;
  end;

 procedure TStrategie.MiniMaxVerfahrenClick(Sender: TObject);
  begin
   MiniMaxVerfahren.Checked:=True;
  end;

 procedure TStrategie.AlphaBetaVerfahrenClick(Sender: TObject);
  begin
   AlphaBetaVerfahren.Checked:=True;
  end;

 procedure TStrategie.LevelWahl(Sender: TObject);
  begin
   if Sender=Level1 then
    Begin Tiefe:=1;Level1.Checked:=True End;
   if Sender=Level2 then
    Begin Tiefe:=2;Level2.Checked:=True End;
   if Sender=Level3 then
    Begin Tiefe:=3;Level3.Checked:=True End;
   if Sender=Level4 then
    Begin Tiefe:=4;Level4.Checked:=True End;
   if Sender=Level5 then
    Begin Tiefe:=5;Level5.Checked:=True End;
   if Sender=Level6 then
    Begin Tiefe:=6;Level6.Checked:=True End;
   if Sender=Level7 then
    Begin Tiefe:=7;Level7.Checked:=True End;
   if Sender=Level8 then
    Begin Tiefe:=8;Level8.Checked:=True End;
   if Sender=Level9 then
    Begin Tiefe:=9;Level9.Checked:=True End;
  end;

End.

